## QtAV-20210414_305e5404.tar.lz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)

project(QTAV)

set(QTAV_MAJOR 1)
set(QTAV_MINOR 13)
set(QTAV_PATCH 0)
set(PROJECT_VERSION ${QTAV_MAJOR}.${QTAV_MINOR}.${QTAV_PATCH})
set(SO_VERSION ${QTAV_MAJOR})

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(POLICY CMP0063) # visibility. since 3.3
  cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0071)
  cmake_policy(SET CMP0071 NEW)
endif()
set(CMAKE_CXX_VISIBILITY_PRESET hidden) #use with -fdata-sections -ffunction-sections to reduce target size
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)


option(BUILD_EXAMPLES "Build examples" ON)
option(BUILD_PLAYERS "Build players" ON)
option(BUILD_TESTS "Build tests" ON)
option(BUILD_QT5OPENGL "Build with Qt5 OpenGL module" ON)
option(BUILD_QML "Build QML interfaces" ON)

list(APPEND CMAKE_FIND_ROOT_PATH ${QTDIR})

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
get_target_property(qmake Qt5::qmake LOCATION)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_HEADERS
    OUTPUT_VARIABLE QT_INSTALL_HEADERS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_LIBS
    OUTPUT_VARIABLE QT_INSTALL_LIBS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_BINS
    OUTPUT_VARIABLE QT_INSTALL_BINS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_QML
    OUTPUT_VARIABLE QT_INSTALL_QML
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_PREFIX
    OUTPUT_VARIABLE QT_INSTALL_PREFIX
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QT5_CFLAGS}")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(POLICY CMP0063) # visibility. since 3.3
  cmake_policy(SET CMP0063 NEW)
endif()
set(CMAKE_CXX_VISIBILITY_PRESET hidden) #use with -fdata-sections -ffunction-sections to reduce target size
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON) # for .moc
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
if(NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(QTAV_INSTALL_HEADERS ${CMAKE_INSTALL_PREFIX}/include)
  set(QTAV_INSTALL_LIBS ${CMAKE_INSTALL_PREFIX}/lib)
  set(QTAV_INSTALL_BINS ${CMAKE_INSTALL_PREFIX}/bin)
  set(QTAV_INSTALL_QML ${QTAV_INSTALL_LIBS}/qml)
else()
  set(CMAKE_INSTALL_PREFIX ${QT_INSTALL_PREFIX} CACHE PATH "default install path" FORCE)
  set(QTAV_INSTALL_HEADERS ${QT_INSTALL_HEADERS})
  set(QTAV_INSTALL_LIBS ${QT_INSTALL_LIBS})
  set(QTAV_INSTALL_BINS ${QT_INSTALL_BINS})
  set(QTAV_INSTALL_QML ${QT_INSTALL_QML})
endif()

message(STATUS "Qt version: ${Qt5Core_VERSION_STRING}")
message(STATUS "Qt prefix: ${QT_INSTALL_PREFIX}")
message(STATUS "QtAV headers prefix: ${QTAV_INSTALL_HEADERS}")
message(STATUS "QtAV libs prefix: ${QTAV_INSTALL_LIBS}")
message(STATUS "QtAV bins prefix: ${QTAV_INSTALL_BINS}")
message(STATUS "QtAV qml prefix: ${QTAV_INSTALL_QML}")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

#set(CMAKE_DEBUG_POSTFIX d)

install(FILES
  cmake/FindQtAV.cmake
  DESTINATION ${QTAV_INSTALL_LIBS}/cmake
)

if(CMAKE_GENERATOR MATCHES "Visual Studio.*")
  set(UCRT_INCLUDE $ENV{UniversalCRTSDKDir}Include\\$ENV{UCRTVersion}\\ucrt)
  set(VC_ARCH $ENV{Platform})
  if(NOT VC_ARCH)
    set(VC_ARCH x86)
  endif()
  set(UCRT_LIB $ENV{UniversalCRTSDKDir}Lib\\$ENV{UCRTVersion}\\ucrt\\${VC_ARCH})
  if(EXISTS ${UCRT_INCLUDE})
  message("VS project. ucrt: ${UCRT_LIB}")
    include_directories(${UCRT_INCLUDE})
    link_libraries(${CMAKE_LIBRARY_PATH_FLAG}${UCRT_LIB})
  endif()
endif()

add_subdirectory(src)

find_package(Qt5Widgets)
if(Qt5Widgets_FOUND)
  add_subdirectory(widgets)
endif()

if(BUILD_QML)
  find_package(Qt5 COMPONENTS Qml Quick)
  if(Qt5Qml_FOUND AND Qt5Quick_FOUND)
      add_subdirectory(qml)
  endif()
endif()

if(BUILD_EXAMPLES OR BUILD_PLAYERS)
  add_subdirectory(examples)
endif()

=== src/CMakeLists.txt ===
set(MODULE QtAV)
# TODO: translations, rpath, uchardet, x11extras, android

include(CheckCCompilerFlag)
include(CheckCXXSourceCompiles)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
INCLUDE(CheckTypeSize)

# set qt dirs first so we can find depends in qt install dir
include_directories(${QTDIR}/include) #TODO: remove. use external/include
get_filename_component(QTDIR "${QTDIR}" ABSOLUTE)

find_package(PkgConfig)

list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/external/include)
list(APPEND EXTRA_LIBS ${CMAKE_LIBRARY_PATH_FLAG}${QTAV_SOURCE_DIR}/external/lib)
if(APPLE)
    if(IOS)
      #set_xcode_property(myioslib IPHONEOS_DEPLOYMENT_TARGET "8.0")
    else()
      list(APPEND EXTRA_INCLUDE /usr/local/include) #macOS only
      list(APPEND EXTRA_LIBS -L/usr/local/lib)
    endif()
endif()
if(EXISTS ${QTAV_SOURCE_DIR}/contrib/capi/capi.h)
    set(HAVE_CAPI 1)
    list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/contrib/capi) # TODO: only files use capi.h
    list(APPEND EXTRA_DEFS -DQTAV_HAVE_CAPI=1)
endif()

pkg_check_modules (AVFORMAT libavformat REQUIRED)
if(${AVFORMAT_FOUND})
    list(APPEND PKG_CONFIG_MODULES AVFORMAT)
    message("Found AVFORMAT: ${AVFORMAT_LINK_LIBRARIES}")
endif()

pkg_check_modules (AVCODEC libavcodec REQUIRED)
if(${AVCODEC_FOUND})
    list(APPEND PKG_CONFIG_MODULES AVCODEC)
    message("Found AVCODEC: ${AVCODEC_LINK_LIBRARIES}")
endif()

pkg_check_modules (SWSCALE libswscale REQUIRED)
if(${SWSCALE_FOUND})
    list(APPEND PKG_CONFIG_MODULES SWSCALE)
    message("Found SWSCALE: ${SWSCALE_LINK_LIBRARIES}")
endif()

pkg_check_modules (AVUTIL libavutil REQUIRED)
if(${AVUTIL_FOUND})
    list(APPEND PKG_CONFIG_MODULES AVUTIL)
    message("Found AVUTIL: ${AVUTIL_LINK_LIBRARIES}")
endif()

pkg_check_modules (AVFILTER libavfilter)
if(${AVFILTER_FOUND})
    list(APPEND PKG_CONFIG_MODULES AVFILTER)
    message("Found AVFILTER: ${AVFILTER_LINK_LIBRARIES}")
endif()

pkg_check_modules (AVDEVICE libavdevice)
if(${AVDEVICE_FOUND})
    list(APPEND PKG_CONFIG_MODULES AVDEVICE)
    message("Found AVDEVICE: ${AVDEVICE_LINK_LIBRARIES}")
endif()

pkg_check_modules (AVRESAMPLE libavresample)
if(${AVRESAMPLE_FOUND})
    list(APPEND PKG_CONFIG_MODULES AVRESAMPLE)
    message("Found AVRESAMPLE: ${AVRESAMPLE_LINK_LIBRARIES}")
endif()

pkg_check_modules (SWRESAMPLE libswresample)
if(${SWRESAMPLE_FOUND})
    list(APPEND PKG_CONFIG_MODULES SWRESAMPLE)
    message("Found SWRESAMPLE: ${SWRESAMPLE_LINK_LIBRARIES}")
endif()

if (NOT AVRESAMPLE_FOUND AND NOT SWRESAMPLE_FOUND)
    message(FATAL_ERROR "swresample or avresample is required")
endif()

list(APPEND EXTRA_DEFS -DBUILD_QTAV_LIB -D__STDC_CONSTANT_MACROS)

check_include_file(ass/ass.h HAVE_ASS_H)
if(HAVE_ASS_H)
  if(HAVE_CAPI) # dynamic load
    if(IOS OR ANDROID OR WindowsPhone OR WindowsStore)
    else()
      set(HAVE_ASS 1)
    endif()
  endif()
  if(NOT HAVE_ASS) # link to ass
    check_library_exists(ass ass_library_init "" HAVE_ASS)
    if(HAVE_ASS)
      set(DYNAMIC_ASS 0)
      list(APPEND EXTRA_DEFS -DCAPI_LINK_ASS)
      list(APPEND EXTRA_LIBS ass)
    endif()
  endif()
endif()
if(HAVE_ASS)
  list(APPEND EXTRA_DEFS -DQTAV_HAVE_LIBASS=1)
  list(APPEND SOURCES
    capi/ass_api.cpp
    subtitle/SubtitleProcessorLibASS.cpp
  )
endif()

set(DYNAMIC_OPENAL ${HAVE_CAPI})
if(APPLE)
  set(HAVE_OPENAL 1)
  if(NOT DYNAMIC_OPENAL)
    list(APPEND EXTRA_LIBS "-framework OpenAL")
  endif()
  list(APPEND EXTRA_DEFS -DHEADER_OPENAL_PREFIX)
else()
  set(OLD_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
  set(CMAKE_REQUIRED_INCLUDES ${EXTRA_INCLUDE})
  check_include_files(AL/al.h HAVE_AL_H)
  set(CMAKE_REQUIRED_INCLUDES ${OLD_REQUIRED_INCLUDES})
  if(HAVE_AL_H)
    if(HAVE_CAPI) #TODO: option(LINK_OPENAL...)
      set(HAVE_OPENAL 1)
      # DYNAMIC_OPENAL is set by user
    else()
      if(WIN32)
        check_library_exists(OpenAL alGetError "" HAVE_OPENAL)
      else()
        check_library_exists(openal alGetError "" HAVE_OPENAL)
        if(NOT HAVE_OPENAL)
            check_library_exists(OpenAL alGetError "" HAVE_OPENAL) # blackberry
            if(HAVE_OPENAL)
              list(APPEND EXTRA_LIBS OpenAL)
            endif()
        else()
            list(APPEND EXTRA_LIBS openal)
        endif()
      endif()
      if(HAVE_OPENAL)
        set(DYNAMIC_OPENAL 0)
      endif()
    endif()
  endif()
endif()
if(HAVE_OPENAL AND NOT DYNAMIC_OPENAL)
  list(APPEND EXTRA_DEFS -DCAPI_LINK_OPENAL)
endif()
if(HAVE_OPENAL)
  list(APPEND SOURCES
    capi/openal_api.cpp
    output/audio/AudioOutputOpenAL.cpp
    )
endif()

if (APPLE)
  set(CMAKE_CXX_SYSTEM_FRAMEWORK_SEARCH_FLAG "-F ") # original is "-iframework", lots of build errors
  set(CMAKE_C_SYSTEM_FRAMEWORK_SEARCH_FLAG "-F ")
  set(OLD_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} avcodec)
  check_c_source_compiles(
    "#include <libavcodec/videotoolbox.h>
    int main() {
        av_videotoolbox_alloc_context();
        return 0;
    }" HAVE_VIDEOTOOLBOX)
  set(CMAKE_REQUIRED_LIBRARIES ${OLD_REQUIRED_LIBRARIES})

  if (HAVE_VIDEOTOOLBOX)
    list(APPEND EXTRA_DEFS -DQTAV_HAVE_VIDEOTOOLBOX=1)
    list(APPEND EXTRA_LIBS "-framework CoreMedia" "-framework VideoToolbox" "-framework CoreVideo")
    list(APPEND SOURCES 
      codec/video/VideoDecoderVideoToolbox.cpp
      codec/video/SurfaceInteropCV.cpp
      )
    if (IOS)
      list(APPEND SOURCES 
        codec/video/SurfaceInteropCVOpenGLES.mm
        )
    else()
      list(APPEND SOURCES 
        codec/video/SurfaceInteropIOSurface.cpp
        )
    endif()
  endif()

  list(APPEND SOURCES output/audio/AudioOutputAudioToolbox.cpp)
  list(APPEND EXTRA_LIBS "-framework CoreFoundation" "-framework AudioToolbox" "-framework OpenGL")
endif()

set(DEP_H  OPENAL VIDEOTOOLBOX)
foreach (D ${DEP_H})
  if (${D})
    ADD_DEFINITIONS(-DQTAV_HAVE_${D}=1)
  endif()
endforeach()

if (AVRESAMPLE_FOUND)
  list(APPEND SOURCES AudioResamplerLibav.cpp)
endif()
if (SWRESAMPLE_FOUND)
  list(APPEND SOURCES AudioResamplerFF.cpp)
endif()

set(HAVE_EGL 0)
set(DYNAMIC_GL 0)
set(OPENGL 0)     #desktop opengl only
set(OPENGLES 0)   #glesv2 only
set(HAVE_OPENGL 1) # qt with opengl enabled. 1 of DYNAMIC_GL, OPENGL and OPENGLES is true
#get_target_property(QtGui_location Qt5::Gui LOCATION) #dll path

if(Qt5Gui_OPENGL_IMPLEMENTATION STREQUAL GL) # windows always set to GL
  if(EXISTS ${QT_INSTALL_HEADERS}/QtANGLE)
    set(DYNAMIC_GL 1) # assume Qt5Gui_OPENGL_IMPLEMENTATION is not GL if build with ANGLE only
    if(NOT DEFINED Qt5Gui_EGL_INCLUDE_DIRS)
      set(Qt5Gui_EGL_INCLUDE_DIRS ${QT_INSTALL_HEADERS}/QtANGLE)
    endif()
  else()
    set(OPENGL 1)
  endif()
  if(DEFINED Qt5Gui_EGL_LIBRARIES) # x11?
    set(HAVE_EGL 1)
  endif()
else()
  set(OPENGLES 1)
endif()
if(OPENGLES OR DYNAMIC_GL)
  set(HAVE_EGL 1)
endif()
if(NOT OPENGL AND NOT OPENGLES AND NOT DYNAMIC_GL)
  set(HAVE_OPENGL 0)
endif()
if(HAVE_OPENGL)
  if(WIN32 AND NOT DYNAMIC_GL AND NOT OPENGLES) # msys2
    find_package(OpenGL REQUIRED)
    list(APPEND EXTRA_LIBS ${OPENGL_gl_LIBRARY})
  endif()
endif()

file(GLOB SDK_HEADERS QtAV/*.h)
list(APPEND SDK_HEADERS QtAV/QtAV)
file(GLOB SDK_PRIVATE_HEADERS QtAV/private/*.h)

list(APPEND SOURCES
    AVCompat.cpp
    QtAV_Global.cpp
    subtitle/CharsetDetector.cpp
    subtitle/PlainText.cpp
    subtitle/PlayerSubtitle.cpp
    subtitle/Subtitle.cpp
    subtitle/SubtitleProcessor.cpp
    subtitle/SubtitleProcessorFFmpeg.cpp
    subtitle/SubImage.cpp
    utils/GPUMemCopy.cpp
    utils/Logger.cpp
    AudioThread.cpp
    utils/internal.cpp
    AVThread.cpp
    AudioFormat.cpp
    AudioFrame.cpp
    AudioResampler.cpp
    AudioResamplerTemplate.cpp
    codec/audio/AudioDecoder.cpp
    codec/audio/AudioDecoderFFmpeg.cpp
    codec/audio/AudioEncoder.cpp
    codec/audio/AudioEncoderFFmpeg.cpp
    codec/AVDecoder.cpp
    codec/AVEncoder.cpp
    AVMuxer.cpp
    AVDemuxer.cpp
    AVDemuxThread.cpp
    ColorTransform.cpp
    Frame.cpp
    FrameReader.cpp
    filter/Filter.cpp
    filter/FilterContext.cpp
    filter/FilterManager.cpp
    filter/LibAVFilter.cpp
    filter/SubtitleFilter.cpp
    filter/EncodeFilter.cpp
    ImageConverter.cpp
    ImageConverterFF.cpp
    Packet.cpp
    PacketBuffer.cpp
    AVError.cpp
    AVPlayer.cpp
    AVPlayerPrivate.cpp
    AVTranscoder.cpp
    AVClock.cpp
    VideoCapture.cpp
    VideoFormat.cpp
    VideoFrame.cpp
    io/MediaIO.cpp
    io/QIODeviceIO.cpp
    output/audio/AudioOutput.cpp
    output/audio/AudioOutputBackend.cpp
    output/audio/AudioOutputNull.cpp
    output/video/VideoRenderer.cpp
    output/video/VideoOutput.cpp
    output/video/QPainterRenderer.cpp
    output/AVOutput.cpp
    output/OutputSet.cpp
    Statistics.cpp
    codec/video/VideoDecoder.cpp
    codec/video/VideoDecoderFFmpegBase.cpp
    codec/video/VideoDecoderFFmpeg.cpp
    codec/video/VideoDecoderFFmpegHW.cpp
    codec/video/VideoEncoder.cpp
    codec/video/VideoEncoderFFmpeg.cpp
    VideoThread.cpp
    VideoFrameExtractor.cpp
    )

if(HAVE_OPENGL)
  aux_source_directory(opengl SRC_OPENGL) 
  list(APPEND SOURCES ${SRC_OPENGL})
  list(APPEND SOURCES
    filter/GLSLFilter.cpp
    output/video/OpenGLRendererBase.cpp
  )
  if(NOT Qt5Gui_VERSION VERSION_LESS 5.4.0)
    list(APPEND SDK_HEADERS QtAV/OpenGLWindowRenderer.h)
    list(APPEND SOURCES output/video/OpenGLWindowRenderer.cpp)
  endif()
endif()

if(HAVE_EGL AND HAVE_CAPI)
  list(APPEND SOURCES capi/egl_api.cpp)
  # TODO: X11Extras
  if(DEFINED Qt5Gui_EGL_INCLUDE_DIRS) # ANGLE
    list(APPEND EXTRA_INCLUDE ${Qt5Gui_EGL_INCLUDE_DIRS})
    #list(APPEND EXTRA_DEFS -DQTAV_HAVE_QT_EGL=1)
    if(NOT IOS)
      list(APPEND EXTRA_DEFS -DQTAV_HAVE_EGL_CAPI=1)
      if(WindowsPhone OR WindowsStore)
        list(APPEND EXTRA_DEFS -DCAPI_LINK_EGL)
      endif()
    endif()
  endif()
endif()
if(WIN32 OR WindowsStore OR WindowsPhone)
  check_include_files(XAudio2.h HAVE_XAUDIO2_H)
  if(NOT HAVE_XAUDIO2_H)
    list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/contrib/dxsdk)
  endif()
  message("Qt5Gui_EGL_INCLUDE_DIRS: ${Qt5Gui_EGL_INCLUDE_DIRS}")
  list(APPEND HEADERS
    output/audio/xaudio2_compat.h
    codec/video/VideoDecoderD3D.h
  )
  list(APPEND SOURCES
    utils/DirectXHelper.cpp
    output/audio/AudioOutputXAudio2.cpp
    codec/video/VideoDecoderD3D.cpp
  )
  list(APPEND EXTRA_DEFS -DQTAV_HAVE_XAUDIO2=1)
  set(OLD_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} avcodec) # TODO: lib dir
  set(OLD_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
  set(CMAKE_REQUIRED_INCLUDES ${EXTRA_INCLUDE} ${CMAKE_CURRENT_SOURCE_DIR})
  check_cxx_source_compiles("
  #include \"directx/dxcompat.h\"
  #include <d3d11.h>
  extern \"C\" {
  #include <libavcodec/d3d11va.h>
  }
  #include <wrl/client.h> //ComPtr is used in QtAV
  int main() {
    av_d3d11va_alloc_context();
    D3D11_VIDEO_PROCESSOR_STREAM s; //used by vp
    return 0;
  }
  " HAVE_D3D11)
  set(CMAKE_REQUIRED_INCLUDES ${OLD_REQUIRED_INCLUDES})
  set(CMAKE_REQUIRED_LIBRARIES ${OLD_REQUIRED_LIBRARIES})
  if(HAVE_D3D11)
    # https://crascit.com/2015/03/28/enabling-cxx11-in-cmake/ (global and specified target)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    list(APPEND EXTRA_DEFS -DQTAV_HAVE_D3D11VA=1)
    list(APPEND SOURCES
      codec/video/VideoDecoderD3D11.cpp
      directx/SurfaceInteropD3D11.cpp
      directx/D3D11VP.cpp
    )
    if(HAVE_EGL)
      list(APPEND SOURCES directx/SurfaceInteropD3D11EGL.cpp)
    endif()
    if(HAVE_OPENGL AND NOT OPENGLES) # dynamic gl or desktop
      list(APPEND SOURCES directx/SurfaceInteropD3D11GL.cpp)
    endif()
  endif()
  if(WindowsStore OR WindowsPhone)
    list(APPEND SOURCES io/WinRTIO.cpp)
    list(APPEND EXTRA_LIBS
      xaudio2 #only for xbox or >=win8
      shcore
    )
    if(HAVE_D3D11)
      list(APPEND EXTRA_LIBS d3d11)
    endif()
  else()
    list(APPEND EXTRA_LIBS ole32 user32) #ole32: CoInitializeEx for vs2008, but can not find the symbol at runtime

=== widgets/CMakeLists.txt ===
set(MODULE QtAVWidgets)
set(EXTRA_DEFS -DBUILD_QTAVWIDGETS_LIB)
list(APPEND EXTRA_DEFS -DQTAV_HAVE_GL=1)

set(HAVE_QT5OPENGL 0)
if(BUILD_QT5OPENGL)
  find_package(Qt5OpenGL)
  if(Qt5OpenGL_FOUND)
    set(HAVE_QT5OPENGL 1)
  endif()
endif()

set(SDK_HEADERS
  QtAVWidgets/global.h
  QtAVWidgets/GraphicsItemRenderer.h
  QtAVWidgets/OpenGLWidgetRenderer.h
  QtAVWidgets/QtAVWidgets
  QtAVWidgets/QtAVWidgets.h
  QtAVWidgets/version.h
  QtAVWidgets/VideoPreviewWidget.h
  QtAVWidgets/WidgetRenderer.h
)
file(GLOB SDK_PRIVATE_HEADERS QtAVWidgets/*.h)

set(SOURCES
  global.cpp
  GraphicsItemRenderer.cpp
  OpenGLWidgetRenderer.cpp
  VideoPreviewWidget.cpp
  WidgetRenderer.cpp
)
if(HAVE_QT5OPENGL)
  list(APPEND SDK_HEADERS QtAVWidgets/GLWidgetRenderer2.h)
  list(APPEND SOURCES GLWidgetRenderer2.cpp)
endif()

# TODO: Qt5Gui_OPENGL_IMPLEMENTATION?
if(Qt5Gui_VERSION VERSION_LESS 5.4.0)
  list(APPEND SDK_HEADERS QtAVWidgets/QOpenGLWidget.h)
  list(APPEND SOURCES QOpenGLWidget.cpp)
endif()

set(HEADERS ${SDK_HEADERS})
if(WIN32)
  set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
  configure_file(${QTAV_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
endif()
# add HEADERS for moc
add_library(${MODULE} SHARED ${SOURCES} ${RESOURCES_SOURCES} ${HEADERS} ${RC_FILE})
target_link_libraries(${MODULE}
  LINK_PRIVATE ${EXTRA_LIBS}
  LINK_PUBLIC QtAV Qt5::Widgets
)
if(HAVE_QT5OPENGL)
  target_link_libraries(${MODULE} LINK_PUBLIC Qt5::OpenGL)
endif()
set_target_properties(${MODULE} PROPERTIES
  MACOSX_RPATH ON
  FRAMEWORK ON
  VERSION ${PROJECT_VERSION}
  SOVERSION ${SO_VERSION}
  OUTPUT_NAME ${MODULE}
  CLEAN_DIRECT_OUTPUT 1
  #LINK_SEARCH_START_STATIC 1
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib
)


#http://stackoverflow.com/questions/19866424/cmake-and-qt5-automoc-error
#http://doc.qt.io/qt-5/cmake-manual.html
set(CMAKE_INCLUDE_CURRENT_DIR ON) # for .moc
target_include_directories(${MODULE}
  PUBLIC $<INSTALL_INTERFACE:include>
  PUBLIC $<INSTALL_INTERFACE:include/${MODULE}>
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}>
  PRIVATE ${EXTRA_INCLUDE}
  )
target_compile_definitions(${MODULE} PRIVATE ${EXTRA_DEFS})


install(FILES
  ${SDK_HEADERS}
  DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}
)
install(FILES
  ${SDK_PRIVATE_HEADERS}
  DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}/private
)
install(TARGETS ${MODULE}
  EXPORT ${MODULE}-targets
  #PUBLIC_HEADER DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}
  #PRIVATE_HEADER DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}/private
  RUNTIME DESTINATION ${QTAV_INSTALL_BINS}
  LIBRARY DESTINATION ${QTAV_INSTALL_LIBS}
  ARCHIVE DESTINATION ${QTAV_INSTALL_LIBS}
  FRAMEWORK DESTINATION ${QTAV_INSTALL_LIBS}
)
install(EXPORT ${MODULE}-targets
  DESTINATION ${QTAV_INSTALL_LIBS}/cmake/${MODULE}
  FILE ${MODULE}-config.cmake
)

=== debian/changelog ===
qtav (1.13.0) unstable; urgency=low

  * Add python bindings
  * More apis for qml player
  * Auto rotate video
  * Apple store
  * Fix ios plugin not found
  * Support chapters
  * Muxer, encoder, transcoder improvements
  * Compatible with new ffmpeg
  * Videotoolbox: hevc
  * Cuda: new devices
  * Android: no longer depends on private qt module
  * Fix opensl error
  * Other improvements, fixes, and untested features

 -- Wang Bin (Lucas) <wbsecg1@gmail.com>  Thu, 11 Jul 2019 08:53:50 +0800

qtav (1.12.0) unstable; urgency=low

  * CMake support
  * Fix iOS build
  * Fix AVPacket memory leak
  * Geometry & GeometryRenderer class is public
  * PAL8, XYZ color format support
  * Fix OpenGL background color
  * Fix external clock error after pause
  * VA-API encoder support (ffmpeg>=3)
  * Other improvements, fixes, and untested features

 -- Wang Bin (Lucas) <wbsecg1@gmail.com>  Tue, 20 Jun 2017 20:44:14 +0800

qtav (1.11.0) unstable; urgency=low

  * Dynamic load QtAVWidgets in VideoOutput. avwidgets module is not requred now.
  * D3D11 decoder support. Not stable on Windows phone.
  * DXVA refactor and bug fix.
  * VA-API: fix memory leak when seeking
  * Fix PBO binding
  * Custom shader support (WIP)
  * Edit and apply custom shader when playing. Based on Qt property system.
  * Optimize uniform update
  * GLSL filter support
  * Add `OpenGLVideo.beforeRendering/afterRendering`
  * CUDA: Direct copy is default on windows. CUDA rendering is faster than any other players
  * CUDA: 0-copy is default for linux.
  * CUDA: Use new API (4.0)
  * Add `AVPlayer.stoppedAt` signal
  * Add `AVPlayer.setTimeRange()`
  * AVPlayer.setStart/StopPosition can be called at any time with any value
  * Ensure all threads are running when `AVPlayer.started` is emitted
  * Support preload using `AVPlayer.load()`. Now no reload in `play()`
  * Fix build with QT_NAMESPACE
  * Fix swscale color range
  * Fix linux install destinations
  * Add AVTranscoder.async, encoders are in individual threads
  * Add FrameReader class
  * Use FFmpeg 3.0 API
  * QML: Support filters, including sw filters from libavfilter, and GLSL filter
  * QML: Add `MediaPlayer/Video.audioBackends` property
  * QML: Support autoLoad
  * QML: Add `VideoOutput.mapTo/FromXXX` between source frame and item
  * QML: Video EQ in VideoOutput/Video
  * QML: Add `MediaPlayer.startPosition/stopPotion`
  * QMLPlayer: Open video and subtitle at the same time. History view. Zoom. Video EQ

 -- Wang Bin (Lucas) <wbsecg1@gmail.com>  Sun, 19 Jun 2016 21:13:08 +0800

qtav (1.10.0) unstable; urgency=low

  * Improve seek speed, fix drop too much frames after seek
  * VideoFrameExtractor seek faster if called many times
  * Speed up progress bar preview
  * Support media files from android assets. Use protocol 'assets:'
  * Apply video decoder options when playing
  * Better iOS support
  * VideoToolbox checks profile to avoid crash
  * VideoToolbox supports RGB output
  * VideoToolbox uses `rgb422_apple` texture
  * VideoToolbox supports iOS 0-copy rendering using OpenGLES
  * More interop types for OSX and iOS
  * Use 16bit depth textures for >8bit videos (e.g. 10bit) if possible
  * Correct input/output color range. Fixes color is different from other players
  * Fix high opengl and core profile rendering
  * Better EGL detection
  * VideoRenderer simplify signal emitting
  * VideoOutput delete crash, resize issues
  * VideoRenderer supports background color, simplify background painting
  * Improve performance of QPainter based renderers
  * AudioOutput remove setBufferSize, add a better API setBufferSamples
  * Add flush(), clear(). Not implemented for backends.
  * Fix OpenAL playback for some audio formats
  * Dynamic load OpenAL by default except iOS
  * Add AudioToolbox support for OSX/iOS and becomes the default backend
  * PulseAudio workaround noise for multiple instance
  * Support ass font files in android assets
  * Fix srt decoding
  * QML add QtMultimedia compatible APIs VideoOutput.contentRect/sourceRect
  * Simplify SurfaceType
  * Fix strange behaviors near eof, seek, stepForward, exit etc.
  * Fix playback block if audio duration is shorter than video
  * VideoFrame constructed from QImage takes image's ownership
  * Add VideoFrame.colorRange, AudioFrame.duration
  * encoder support start time
  * Add AVPlayer.bufferSpeed, seekFinished(qint64)
  * Fix abort when loading
  * Fix videos in videowall not synchronized
  * QMLPlayer has better touch screen experience
  * QMLPlayer supports win10 store (But Qt is not well supported)
  * Player/QMLPlayer Drag & Drop support on OSX
  * QMLPlayer URL open dialog for QMLPlayer

 -- Wang Bin (Lucas) <wbsecg1@gmail.com>  Wed, 02 Mar 2016 10:44:44 +0800

qtav (1.9.0) unstable; urgency=low

  * No audio thread if audio stream < 0. null AudioOutput now still create audio thread.
  * VideoOutput: fix lock error
  * Filter: add X11 text rendering for X11Renderer/XVRenderer.
  * LibAVFilter supports HW frames(not recommended)
  * VideoFrame copy and init issue, bpp compute error
  * Avoid using some stl APIs that breaks ABI
  * Add x11 renderer
  * XV: support NV12 and packed yuv formats
  * Fix factory initialization for static build(iOS for example)
  * Fix ffmpeg log level
  * Remove AVPicture which is deprecated
  * SWS 16 alignment, output to user defined buffer
  * Always define the registered id so we can use everywhere
  * Better iOS support: build, run, deploy(prl)
  * use libuchardet now, use system one if possible
  * Fix android build on windows
  * XAudio2: fix crash. `double` sample format is not supported
  * Fix clock value if speed changed
  * VideoRenderer.updateUi
  * VideoCapture: fix HW frame save
  * New logo
  * Android: support protocol 'content'. Now can play from Gallery.
  * MediaIO is not writable by default
  * WinRT (Windows Store) support
  * VA-API: Add hevc, vp9. Not tested
  * VA-API:Support more profiles
  * VA-API: Improve nvidia support


=== debian/control ===

Source: qtav
Section: video
Priority: optional
Maintainer: Wang Bin <wbsecg1@gmail.com>
Build-Depends: debhelper (>= 9),
 qt5-qmake, libqt5opengl5-dev, qtdeclarative5-dev,
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 libass-dev,
 libavutil-dev,
 libavresample-dev,
 libavcodec-dev,
 libavformat-dev,
 libavdevice-dev,
 libavfilter-dev,
 libswscale-dev,
 libopenal-dev,
 libpulse-dev,
 libxv-dev,
 libva-dev,
 libegl1-mesa-dev,
 libuchardet-dev,
Standards-Version: 3.9.5
Homepage: http://qtav.org

Package: qtav-sdk
Architecture: all
Section: libdevel
Depends: ${misc:Depends}, qtav-dev, qtav-private-dev, qml-module-qtav
Description: FFmpeg powered multimedia playback SDK for Qt
 QtAV can help you to write a player with less effort than ever before.
 .
 Features include:
   * Hardware decoding suppprt: DXVA2, VAAPI, VDA, VideoToolbox, CedarX, CUDA
   * Realtime preview
   * OpenGL and ES2 support for Hi10P and other 16-bit YUV videos
   * Video capture in rgb and yuv format
   * OSD and custom filters
   * filters in libavfilter, for example stereo3d, blur
   * Subtitles
   * Playback speed control
   * Variant streams: locale file, http, rtsp, etc.
   * Multiple render engine support. Currently supports QPainter, GDI+, Direct2D, XV and OpenGL(and ES2).
   * Dynamically change render engines and decoders when playing.
   * Multiple video outputs for 1 player
   * Region of interest(ROI), i.e. video cropping
   * Video eq: brightness, contrast, saturation, hue
   * QML support as a plugin. Most playback APIs are compatible with QtMultiMedia module

Package: libqtav
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libegl1-mesa, libva-x11-1, libva-drm1, libva-glx1, i965-va-driver, vdpau-va-driver
Description: QtAV library
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the QtAV library.

Package: libqtavwidgets
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}, libqtav, libqt5opengl5
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QtAV Widgets module
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
  This package contains a set of widgets to play media.

Package: qtav-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libqtav, libqtavwidgets, libqt5opengl5-dev
Description: QtAV development files
 QtAV is a multimedia playback framework based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the header development files for building some
 QtAV applications using QtAV headers.

Package: qtav-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: qtav-dev (= ${binary:Version}), ${misc:Depends}
Description: QtAV private development files
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the private header development files for building some
 QtAV applications using QtAV private headers.
 .
 Use at your own risk.

Package: qml-module-qtav
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: QtAV QML module
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the QtAV QML module for Qt declarative.

Package: qtav-players
Section: video
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libqtav, libqtavwidgets, qml-module-qtav, libqt5svg5, qtdeclarative5-dialogs-plugin, qtdeclarative5-controls-plugin, qtdeclarative5-folderlistmodel-plugin, qtdeclarative5-settings-plugin
Multi-Arch: same
Description: QtAV/QML players
 QtAV is a multimedia playback framework based on Qt and FFmpeg.
 High performance. User & developer friendly.
 .
 This package contains the QtAV based players

=== msys2/PKGBUILD ===
realname=qtav
pkgname="${MINGW_PACKAGE_PREFIX}-${realname}"
pkgver=r3368.39e6eafe
pkgrel=1
pkgdesc="Multimedia framework based on Qt and FFmpeg (mingw-w64)"
arch=('any')
license=('LGPL')
depends=("${MINGW_PACKAGE_PREFIX}-uchardet"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-openal"
         "${MINGW_PACKAGE_PREFIX}-qt5")
makedepends=('git')
source=("${realname}::git://github.com/wang-bin/QtAV.git")
md5sums=('SKIP')

pkgver() {
  cd "${srcdir}/${realname}"
  printf "r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
}

prepare() {
  cd "${srcdir}/${realname}"
  git submodule update --init
}

build() {
  cd "${srcdir}/${realname}"
  
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  cmake \
    -G"MSYS Makefiles" \
    -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_PLAYERS=ON \
    -DBUILD_TESTS=OFF \
    ../${realname}

  make
}

package() {
  cd "${srcdir}/${realname}"
  
  make DESTDIR="${pkgdir}" install
  
  mkdir -p "${pkgdir}${MINGW_PREFIX}/share/licenses/${realname}"
  cp lgpl-2.1.txt "${pkgdir}${MINGW_PREFIX}/share/licenses/${realname}/LICENSE"
}

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
export QT_SELECT=qt5

%:
	dh $@ --parallel

override_dh_auto_configure:
	qmake "CONFIG+=no_rpath recheck config_libass_link config_openal_link no-tests"
